/**
 *                                                                            
 *  Copyright (c) 2011, 2016 - Loetz GmbH&Co.KG (69115 Heidelberg, Germany) 
 *                                                                            
 *  All rights reserved. This program and the accompanying materials           
 *  are made available under the terms of the Eclipse Public License 2.0        
 *  which accompanies this distribution, and is available at                  
 *  https://www.eclipse.org/legal/epl-2.0/                                 
 *                                 
 *  SPDX-License-Identifier: EPL-2.0                                 
 *                                                                            
 *  Contributors:                                                      
 * 	   Christophe Loetz (Loetz GmbH&Co.KG) - initial implementation
 * 
 */
 package org.eclipse.osbp.ecview.core.common.model.binding.provider;

import java.util.ArrayList;
import java.util.Collection;

import java.util.List;
import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ChildCreationExtenderManager;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IChildCreationExtender;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.osbp.ecview.core.common.model.binding.BindingPackage;
import org.eclipse.osbp.ecview.core.common.model.binding.util.BindingAdapterFactory;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class BindingItemProviderAdapterFactory extends BindingAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable, IChildCreationExtender {
	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComposedAdapterFactory parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IChangeNotifier changeNotifier = new ChangeNotifier();

	/**
	 * This helps manage the child creation extenders.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ChildCreationExtenderManager childCreationExtenderManager = new ChildCreationExtenderManager(ECViewCoreEditPlugin.INSTANCE, BindingPackage.eNS_URI);

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Collection<Object> supportedTypes = new ArrayList<Object>();

	/**
	 * This constructs an instance.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BindingItemProviderAdapterFactory() {
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.common.model.binding.YBindingSet} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YBindingSetItemProvider yBindingSetItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.common.model.binding.YBindingSet}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYBindingSetAdapter() {
		if (yBindingSetItemProvider == null) {
			yBindingSetItemProvider = new YBindingSetItemProvider(this);
		}

		return yBindingSetItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.common.model.binding.YBeanValueBindingEndpoint} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YBeanValueBindingEndpointItemProvider yBeanValueBindingEndpointItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.common.model.binding.YBeanValueBindingEndpoint}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYBeanValueBindingEndpointAdapter() {
		if (yBeanValueBindingEndpointItemProvider == null) {
			yBeanValueBindingEndpointItemProvider = new YBeanValueBindingEndpointItemProvider(this);
		}

		return yBeanValueBindingEndpointItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.common.model.binding.YDetailValueBindingEndpoint} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YDetailValueBindingEndpointItemProvider yDetailValueBindingEndpointItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.common.model.binding.YDetailValueBindingEndpoint}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYDetailValueBindingEndpointAdapter() {
		if (yDetailValueBindingEndpointItemProvider == null) {
			yDetailValueBindingEndpointItemProvider = new YDetailValueBindingEndpointItemProvider(this);
		}

		return yDetailValueBindingEndpointItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.common.model.binding.YValueBinding} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YValueBindingItemProvider yValueBindingItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.common.model.binding.YValueBinding}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYValueBindingAdapter() {
		if (yValueBindingItemProvider == null) {
			yValueBindingItemProvider = new YValueBindingItemProvider(this);
		}

		return yValueBindingItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.common.model.binding.YListBinding} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YListBindingItemProvider yListBindingItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.common.model.binding.YListBinding}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYListBindingAdapter() {
		if (yListBindingItemProvider == null) {
			yListBindingItemProvider = new YListBindingItemProvider(this);
		}

		return yListBindingItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.common.model.binding.YEnumListBindingEndpoint} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YEnumListBindingEndpointItemProvider yEnumListBindingEndpointItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.common.model.binding.YEnumListBindingEndpoint}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYEnumListBindingEndpointAdapter() {
		if (yEnumListBindingEndpointItemProvider == null) {
			yEnumListBindingEndpointItemProvider = new YEnumListBindingEndpointItemProvider(this);
		}

		return yEnumListBindingEndpointItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.common.model.binding.YECViewModelValueBindingEndpoint} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YECViewModelValueBindingEndpointItemProvider yecViewModelValueBindingEndpointItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.common.model.binding.YECViewModelValueBindingEndpoint}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYECViewModelValueBindingEndpointAdapter() {
		if (yecViewModelValueBindingEndpointItemProvider == null) {
			yecViewModelValueBindingEndpointItemProvider = new YECViewModelValueBindingEndpointItemProvider(this);
		}

		return yecViewModelValueBindingEndpointItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.common.model.binding.YECViewModelListBindingEndpoint} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YECViewModelListBindingEndpointItemProvider yecViewModelListBindingEndpointItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.common.model.binding.YECViewModelListBindingEndpoint}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYECViewModelListBindingEndpointAdapter() {
		if (yecViewModelListBindingEndpointItemProvider == null) {
			yecViewModelListBindingEndpointItemProvider = new YECViewModelListBindingEndpointItemProvider(this);
		}

		return yecViewModelListBindingEndpointItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.common.model.binding.YVisibilityProcessorValueBindingEndpoint} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YVisibilityProcessorValueBindingEndpointItemProvider yVisibilityProcessorValueBindingEndpointItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.common.model.binding.YVisibilityProcessorValueBindingEndpoint}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYVisibilityProcessorValueBindingEndpointAdapter() {
		if (yVisibilityProcessorValueBindingEndpointItemProvider == null) {
			yVisibilityProcessorValueBindingEndpointItemProvider = new YVisibilityProcessorValueBindingEndpointItemProvider(this);
		}

		return yVisibilityProcessorValueBindingEndpointItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.common.model.binding.YNoOpValueBindingEndpoint} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YNoOpValueBindingEndpointItemProvider yNoOpValueBindingEndpointItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.common.model.binding.YNoOpValueBindingEndpoint}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYNoOpValueBindingEndpointAdapter() {
		if (yNoOpValueBindingEndpointItemProvider == null) {
			yNoOpValueBindingEndpointItemProvider = new YNoOpValueBindingEndpointItemProvider(this);
		}

		return yNoOpValueBindingEndpointItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.common.model.binding.YNoOpListBindingEndpoint} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YNoOpListBindingEndpointItemProvider yNoOpListBindingEndpointItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.common.model.binding.YNoOpListBindingEndpoint}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYNoOpListBindingEndpointAdapter() {
		if (yNoOpListBindingEndpointItemProvider == null) {
			yNoOpListBindingEndpointItemProvider = new YNoOpListBindingEndpointItemProvider(this);
		}

		return yNoOpListBindingEndpointItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class<?>) || (((Class<?>)type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public List<IChildCreationExtender> getChildCreationExtenders() {
		return childCreationExtenderManager.getChildCreationExtenders();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Collection<?> getNewChildDescriptors(Object object, EditingDomain editingDomain) {
		return childCreationExtenderManager.getNewChildDescriptors(object, editingDomain);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResourceLocator getResourceLocator() {
		return childCreationExtenderManager;
	}

	/**
	 * This adds a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void dispose() {
		if (yBindingSetItemProvider != null) yBindingSetItemProvider.dispose();
		if (yBeanValueBindingEndpointItemProvider != null) yBeanValueBindingEndpointItemProvider.dispose();
		if (yDetailValueBindingEndpointItemProvider != null) yDetailValueBindingEndpointItemProvider.dispose();
		if (yValueBindingItemProvider != null) yValueBindingItemProvider.dispose();
		if (yListBindingItemProvider != null) yListBindingItemProvider.dispose();
		if (yEnumListBindingEndpointItemProvider != null) yEnumListBindingEndpointItemProvider.dispose();
		if (yecViewModelValueBindingEndpointItemProvider != null) yecViewModelValueBindingEndpointItemProvider.dispose();
		if (yecViewModelListBindingEndpointItemProvider != null) yecViewModelListBindingEndpointItemProvider.dispose();
		if (yVisibilityProcessorValueBindingEndpointItemProvider != null) yVisibilityProcessorValueBindingEndpointItemProvider.dispose();
		if (yNoOpValueBindingEndpointItemProvider != null) yNoOpValueBindingEndpointItemProvider.dispose();
		if (yNoOpListBindingEndpointItemProvider != null) yNoOpListBindingEndpointItemProvider.dispose();
	}

}
